# 11.1 데이터 형 
x <- c()                # x에 아무것도 들어있지 않은 벡터를 넘겨준다 
x
log(-2)
log(-2+0i)
"abc"
""                      # 내용은 "와 " 안에 있는 것(여기에서는 아무것도 없다는 것을 나타낸다)
"I don't agree."
"\"                     # \ 마크는 단독으로 사용할 수 없다 

# 11.2 출력 
x <- "one"
x                       # 오브젝트 이름만 넣어도 표시되지만 함수 print()를 사용하면 인수 digits, justify,
print(x)                # max.level, na.print, quote, width, zero.print 등으로 출력을 커스터마이즈할 수 있다 
print(x, quote=F)

cat("cd C:\\Document and Settings\\usr\\ \n")
cat("\123\n")
cat(" a'a \n")
cat(" a\"a \n")

sprintf("%s is %f feet tall\n", "Seven", 7)
sprintf("%s is %i feet tall\n", "Seven", as.integer(7))

x <- c(1,2,3,4,5)
str(x)
summary(x)

x <- c(1,2,3,4,5)
comment(x) <- c("x : 1 x 5 vector", "Oct 04, 2009")
x
comment(x)
str(x)

sink("output.txt")  
sink()  

options(digits=15)                     # 표시자리수를 15자리로 바꾼다 
options(scipen=0);  print(1e5)
options(scipen=1);  print(1e5)

x <- runif(10)
x
options(width=50)
x



# 11.3. 벡터 
1 + 2

( x <- c(1.0, 2.0, 3.0, 4.0, 5.0) )    # 길이 5인 벡터 
length(x)                              # 벡터 x의 길이 
( c <- c(1.0, 2.0, 3.0) )              # c라는 변수에 벡터를 대입 
1:10                                   # 1에서 10까지 하나씩 증가한다 
3:-3                                   # 3에서 -3까지 하나씩 증가한다 
seq(1, 10, length=5)                   # 1에서 10까지를 등분할 했다  
( x <- rep(c("A","B","C"), 1:3) )
unique(x)                              # ­반복된 값을 제거한다 
match(x, c("A", "C"))                  # x 안에 A 또는 C가 있는가 ? 

c(1, 20, 3) == c(1, 2, 3)              # 1==1,   20==2,   3==3
c(1, 20, 3) == c(1.0, 2.0, 3.0)        # 1==1.0, 20==2.0, 3==3.0
x <- c(1, 2, 3)
((x >= c(1, 1, 1)) | (x < c(3,3,3)))
((x >= c(1, 1, 1)) & (x < c(3,3,3)))
c(1, 20, 3) > 4                        # 1 > 4 , 20 > 4 , 3 > 4

x <- rnorm(30)                             # 30개의 정규난수 
which( abs(x-1.0) == min(abs(x-1.0)) )     # 1.0에 가장 가까운 값을 
x[which( abs(x-1.0) == min(abs(x-1.0)) )]  # 해당하는 요소의 값 

(x <- c(sort(sample(1:20, 9)),NA))
(y <- c(sort(sample(3:23, 7)),NA))
union(x, y)          # 합집합 
intersect(x, y)      # 곱집합 
setdiff(x, y)        # 차집합 (x에서 x 와 y의 공통 요소를 삭제)
setdiff(y, x)        # 차집합 (y에서 x 와 y의 공통 요소를 삭제
setequal(x, y)       # 집합으로서 같은가 ?

c(1+1i, 2+3i)        # 허수 1+i를 나타낼 때는 1+1i로 표기한다
c(1, 2+3i)           # 요소에 하나라도 복소수가 발견되면 
complex(re=1:3, im=4:6)            # re : 실수부 im : 허수부  
complex(mod=c(1,2), arg=c(0, pi))  # mod : 절대값, arg:편각 
c(T, F, T, TRUE, FALSE)
 c(T, F, T) | c(TRUE, FALSE, FALSE)
!c(T, F, T)
xor( c(TRUE, FALSE, TRUE), c(TRUE, FALSE, FALSE) )
(x <- runif(3))
(0.25 <= x) & (x <= 0.75)       # 0.25 ~ 0.75 범위인가 
(x <- runif(5))
any(x > 0.8)                    # x 안에 하나라도 0.8 이상인 요소가 있는가 
all(x < 0.8)                    # x의 요소는 모두 0.8 이하인가 

c("a", "b", "c", "d", "e")
c("HOKKAIDO", "SENDAI", "TOKYO", "NAGOYA", "OSAKA", "HAKATA")
"TOKYO" > "OSAKA"
"HAKATA" > "OSAKA"
paste("May I", "help you ?")
paste(month.abb, 1:12, c("st", "nd", "rd", rep("th",9)) )
paste("/usr", "local", "bin", sep = "/")   # /를 사이에 끼워 연결 
( x <- paste(1:4) )
paste(x, collapse="abc")
paste(x, collapse="")
substring("abcdefg", 2, 5)
a <- numeric(5);  x <- 1:5
for(i in x) eval(parse(text=paste("a[",i,"] <- 10", sep="") ))
a
x <- c("sex", "height", "age", "weight", "eight")
grep('^ei', x)                 #  ei로 시작되는 요소 
grep('(ei)', x)                # ei이라는 문자열이 있는 요소 
data(warpbreaks)               # 1대의 방적기 당 꼬임파손 수 
attach(warpbreaks)             # 사용하는 데이터를 고정 
( fc <- factor(tension) )      # 요소를 그룹화 
levels(fc)                     # 그룹화되었는지 확인 
str(fc)                        # 오브젝트의 요약값을 표시 
fc <- ordered(tension)
levels(fc)                     # 그릅화되었는지 확인 
str(fc)                        # 오브젝트의 요약값을 표시 
x <- 1:10
cut(x, breaks=c(0,3,7,10))
( y <- cut(x, breaks=c(0,3,7,10), labels=c("Low","Mid","Hi")) )
table(y)
gl(2, 10, 20)
gl(2, 8, label = c("Control", "Treat"))
library(car)
( x <- as.factor(rep(1:4,2)) )
recode(x, "c(1,2)='A'; else='B'")
( y <- recode(x, "1:2='A'; 3='B'; 4='C'") )
relevel(y, "B")

as.Date("2009/07/17")
as.Date("07/17/2009", format="%m/%d/%Y")
Sys.setlocale("LC_TIME","C")
as.Date("2009/Jul/17", format="%Y/%b/%d")
Sys.setlocale("LC_TIME","C")
strptime("17Jul2009", "%d%b%Y")
format(Sys.time(), "%Y %b %d %H:%M:%S %Z")
x <- as.Date(c("2009/07/01","2009/07/15","2009/07/31"))
x[2]-x[1]                   # 날짜의 차이
diff(x)                     # 날짜의 차이
mean(x)                     # 날짜의 평균 
pi/2
month.abb
LETTERS[1:5]

( x <- c(1, 2, 3, 4, 5) )
x[2]
x[2:5]
x[c(-1,-3)]
x[c(F, T, F, T, F)]
x <- c(10, 20, 30, 40, 50)
x[30 < x]
x[10 < x & x < 40]                   # 2개의 조건은 & 와  
(1:length(x))[10 < x & x < 40]       # 몇번째의 요소가 
names(x) <- c("A", "B", "C", "D", "E")
x["A"]

x <- c(1, 2, 3, 4, 5)                # x <- 1:5 라도 좋다 
( y <- replace(x, c(2,4), c(0,0)) )  # x의 2, 4번째의 요소를 
( z <- replace(x, c(2,4), NA) )      # 이번에는 NA로 치환한다 
replace(z, which(is.na(z)), 10)      # z의 NA를 10으로 치환한다 
x <- c(1, 2, 3);  y <- c(4, 5, 6);  z <- c(7, 8, 9)
c(x, y, z)
( w <- append(x, z) )                # c(x, z) 라도 좋다 
append(w, y, after=3)                # w의 세 번째 요소 뒤에 y를 삽입 

x <- c(1.0, NA, 3.0, 4.0)            # NA는 어느 것인지 조사해도.... 
x == NA                              # NA에 대한 연산은 모두 NA가 된다 
is.na(NA)
is.nan(NA)
x <- c(1, NA, 3, 4)
is.na(x)
x <- c(1, 2, NA, 4, 5, NA)
x
x <- ifelse(is.na(x), 0, x)          # NA를 0으로 치환한다 
x
x <- c(1, 2, NA, -4, 5, -6, 7, NA, 9, 10)
y <- x[!is.na(x)]                    # NA 이외의 x의 요소를 y에 저장
y
x <- c(1, 2, NA, -4, 5, -6, 7, NA, 9, 10)
y <- x[(!is.na(x)) & (x > 0)]        # NA와 음수 값 이외의 x의 요소를 
y                                    # y에 저장 
length(NULL)                         # 모드 NULL을 가진다 
x <- 1:3
names(x)                             # names 속성이 없으므로 NULL이 반환된다
names(x) <- c("a", "b", "c")
x
names(x) <- NULL
x
x <- NULL                            # 길이 0인 벡터 x를 준비 
for (i in 1:10) x <- append(x, i*i)  # x에 i^2을 차례로 저장 
x

x <- c(1, 0, 1, 0, 1)
mode(x)
mode(x) <- "complex"      # storage.mode(x) <- "complex"로도 가능 
x
mode(x) <- "logical"
x
x <- c(1, 0, 1, 0, 1, 0)  # x에 벡터를 부가 
is.list(x)                # 벡터는 리스트가 아니다 
x <- as.list(x)           # x를 리스트로 변환 
is.list(x)                # x는 리스트이고 
is.vector(x)              # 리스트는 벡터이기도 하다 



# 11.4. 배열 
( x <- array(1:8, dim=c(1, 4, 2)) )   # 3차원 배열 
x[1, 4, ]                             # x[행, 열, 3차원 요소,...] 
apply(x, 2, mean)         # 열에 대해 :mean(x[ ,i]) (i=1,2,...)와 같은 계산 
apply(x, 1, mean)         # 행에 대해 : mean(x[i, ]) (i=1,2,...)와 같은 계산 
x <- array(1:16, dim=c(2, 4, 2))
apply(x, c(1,2), mean) 
addmargins(x, margin=3, FUN=mean)     # 결과는 생략 

x  <- array(1:24, 2:4)                # 4차원 배열 
aperm(x, perm=c(2,1,3))               # x를 전치한 배열 



# 11.5. 리스트 
( x <- list(1:5, list("It's my list.", c(T, F, T))) )

x <- list(1:5, list("It's my list.", c(T, F, T)))
length(x)                # 리스트 x의 길이를 구한다 
x[[1]] <- NULL           # 리스트의 ­제1성분을 제거 
x[[1]][1]                # x의 제2성분(리스트)의 제1성분을 추출 
x <- as.list(NULL)       # 리스트 x를 초기화 
x                        # x의 내용을 확인 

x[1:2]                   # 제1, 제2 성분을 추출 
x[-1]                    # 제1 성분 이외의 성분을 추출 
x[c(T,F,T)]              # 제1, 제3 성분을 추출 
x[2] <- c(1+2i, 3+4i)               # 리스트의 일부를 벡터로
( x[2] <- list(c(1+2i, 3+4i)) )     # 리스트로 변환하고 나서 치환한다 
c( list(1:5), list(c(T,F,T)) )      # append(list(1:5), 
rep(list(1:5, "It's my list."), 2)  # 함수 rep()도 사용 가능 
( x <- split(1:10, rep(c("odd", "even"), 5)) )
unlist(x)



# 11.6. 데이터 프레임 
id     <- c(1, 2, 3, 4, 5)
sex    <- c("F","F","M","M","M")
height <- c(158,162,177,173,166)
weight <- c( 51, 55, 72, 57, 64)
( x    <- data.frame(ID=id, SEX=sex, HEIGHT=height, WEIGHT=weight) )
x[,c(1,3)]                         # 1열과 3열 표시
x$SEX                              # 열(변수) SEX를 표시 


# 11.7. apply() 패밀리 
( x <- matrix(1:8, ncol=4) )
apply(x, 2, sum)                   # 각 열의 총합을 구한다 
colSums(x)                         # 각 열의 총합을 구한다 
apply(x, c(1,2), sqrt)             # 각 요소의 평방근을 구한다 
( x <- matrix(1:8, ncol=4) )
apply(x, 1, function(x) var(x)*length(x)/(length(x)-1) )

( x <- matrix(1:8, ncol=4) )
sweep(x, 1, 1:2)                   # ­열별로 1행째부터 1을 2행째부터 2를 뺀다 
sweep(x, 2, 1:2)                   # 행별로 c(1:2,1:2) = c(1,2,1,2)를 뺀다 ­
x <- matrix(1:8, ncol=4)
sweep(x, 1, apply(x,1,mean))       # 행평균을 뺀다 ­
sweep(x, 2, apply(x,2,mean))       # 열평균을 뺀다 ­

id     <- c(1, 2, 3, 4, 5)
sex    <- c("F","F","M","M","M")
height <- c(158,162,177,173,166)
weight <- c( 51, 55, 72, 57, 64)
( x    <- data.frame(ID=id, SEX=sex, HEIGHT=height, WEIGHT=weight) )
lapply(x[,-2], mean)               # 각열(각변수)별 평균값을 구한다 
sapply(x[,-2], mean)               # 각열(각변수)별 평균값을 구한다 
id     <- c(1, 2, 3, 4, 5)
sex    <- c("F","F","M","M","M")
height <- c(158,162,177,173,166)
weight <- c( 51, 55, 72, 57, 64)
( x    <- data.frame(ID=id, SEX=sex, HEIGHT=height, WEIGHT=weight) )
tapply(x$HEIGHT, x$SEX, mean)      # 성별(SEX)별로 HEIGHT의 평균값을 구한다 
by(x[,-2], x$SEX, mean)            # 성별(SEX)별로 평균값을 구한다  
aggregate(x[,-2], list(SEX=x$SEX), mean)

id   <- c(1, 2, 3, 4, 5)
wgt1 <- c( 51, 55, 72, 57, 64)
wgt2 <- c( 53, 54, 70, 57, 69)
( x  <- data.frame(ID=id, WEIGHT1=wgt1, WEIGHT2=wgt2) )
mapply(mean, x)                    # 각 열(각 변수)별 평균값을 구한다 
sapply(x, mean)                    # 각 열(각 변수)별 평균값을 구한다 
mapply(function(a,b) mean(c(a,b)), x[,2], x[,3])
mapply(rep, 1:3, 3:1)              # rep(1,3), rep(2,2), rep(3,1)을 나열한다 
mapply(rep, 3:1, 1:3)              # rep(3,1), rep(2,2), rep(1,3)을 나열한다 



# 11.8. names 속성과 요소의 라벨 
x <- 1:5
names(x) <- c("a","b","c","d","e")
x
names(x)
x["b"]
x["c"][[1]]
x <- list(1:5, "abc")
names(x) <- c("sequence", "letters")
x
x$letters                   # 이름 letters로 요소에 접근한다 
temp <- "sequence"          # temp에 문자열 "sequence"가 대입된다 
x[[temp]]                   # [[ ]]의 안의 식은 평가되므로 이는  x[["sequence"]]로 인식된다 
x$temp                      # $ 뒤의 식은 평가되지 않아 x$temp로 인식되므로 NULL이 돌아온다
list(sequence=1:5, "letters"="abc")
a <- matrix(1:6, nrow=2, ncol=3)
dimnames(a) <- list(c("row1","row2"), c("col1","col2","col3"))
a
a <- array(1:16, dim=c(2, 4, 2))
dimnames(a) <- list(NULL, c("A", "B", "C", "D"), c("a", "b"))
a                                                            
dimnames(a) <- list(c("row1","row2"), NULL)   # 열 라벨 삭제 
dimnames(a) <- NULL                           # 모든 라벨 삭제 
x <- 1:4
mode(x)                     # x의 속성을 조사한다  
attributes(x)               # mode와 length 이외의 모든 속성값을 조사한다 
attr(x, "dim") <- c(2,2)
